## oxide-qt 1.15.8

=== CMakeLists.txt ===
# vim:expandtab:shiftwidth=2:tabstop=2:

# Copyright (C) 2014-2016 Canonical Ltd.

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

if(EXISTS ${CMAKE_BINARY_DIR}/CMakeLists.txt)
  message(FATAL_ERROR
          "In-source-tree builds are unsupported. You must use a separate build "
          "directory to build Oxide. Note that you will need to remove the "
          "CMakeCache.txt file from the root of your source tree before continuing")
endif()

cmake_minimum_required(VERSION 2.8.11)
project(OXIDE)

include(CheckCXXCompilerFlag)
include(CheckIncludeFileCXX)
include(GNUInstallDirs)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/build/cmake)

include(OxideCommonOptions)
include(OxideCommonProperties)
include(OxideLibUtils)

# Define variables used throughout the build
if(DEFINED CMAKE_BUILD_TYPE AND CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(CHROMIUM_BUILD_TYPE Debug)
else()
  set(CHROMIUM_BUILD_TYPE Release)
endif()
set(CHROMIUM_OUTPUT_DIR ${CMAKE_BINARY_DIR}/out/chromium)
set(CHROMIUM_PRODUCT_DIR ${CHROMIUM_OUTPUT_DIR}/${CHROMIUM_BUILD_TYPE})
set(CHROMIUM_LIB_DIR ${CHROMIUM_PRODUCT_DIR}/lib)
set(OXIDE_OUTPUT_DIR ${CMAKE_BINARY_DIR}/out)
set(OXIDE_BIN_OUTPUT_DIR ${OXIDE_OUTPUT_DIR}/bin)
set(OXIDE_LIB_OUTPUT_DIR ${OXIDE_OUTPUT_DIR}/lib)
set(OXIDE_PACKAGE_STAGE_DIR ${CMAKE_BINARY_DIR}/_package_stage)

# Use gold everywhere
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fuse-ld=gold")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fuse-ld=gold")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fuse-ld=gold")

# Required for out-of-tree builds
set(CMAKE_INCLUDE_CURRENT_DIR TRUE CACHE INTERNAL "")
# We have a script for loading apps from the tree
set(CMAKE_SKIP_BUILD_RPATH TRUE)
include_directories(${CMAKE_SOURCE_DIR})

# Allow the version number to be used in the build
string(REGEX REPLACE "([^\\.]+)\\.([^\\.]+)\\.([^\\.]+)" "\\1" PROJECT_VERSION_MAJOR ${PROJECT_VERSION})
string(REGEX REPLACE "([^\\.]+)\\.([^\\.]+)\\.([^\\.]+)" "\\2" PROJECT_VERSION_MINOR ${PROJECT_VERSION})
string(REGEX REPLACE "([^\\.]+)\\.([^\\.]+)\\.([^\\.]+)" "\\3" PROJECT_VERSION_PATCH ${PROJECT_VERSION})

# for dh_translations to extract the domain
# (regarding syntax consistency, see http://pad.lv/1181187)
set(GETTEXT_PACKAGE "oxide-${OXIDE_PLATFORM}")
add_definitions(-DOXIDE_GETTEXT_DOMAIN="${GETTEXT_PACKAGE}")

# Check we have a new enough compiler
# FIXME: Support clang
if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8)
  message(FATAL_ERROR "Oxide requires at least GCC 4.8 to build")
endif()
CHECK_CXX_COMPILER_FLAG("-std=c++11" _COMPILER_HAS_CXX11_RESULT)
if(NOT _COMPILER_HAS_CXX11_RESULT)
  message(FATAL_ERROR "Oxide requires a compiler that supports -std=c++11")
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

# Import the configuration for this build
include(${CMAKE_SOURCE_DIR}/${OXIDE_PLATFORM}/config.cmake)

# Set extra variables that depend on the configuration
calculate_versioned_library_filename(OXIDE_LIB_FILENAME ${OXIDE_LIB} ${OXIDE_LIB_VERSION})
calculate_library_filename(OXIDE_LIB_FILENAME_DEV ${OXIDE_LIB})

if(ENABLE_COMPONENT_BUILD)
  link_directories(${CHROMIUM_LIB_DIR})
endif()

if(ENABLE_TESTS)
  enable_testing()
  add_test(NAME shared_unittests
           COMMAND ${CHROMIUM_PRODUCT_DIR}/oxide_shared_unittests)
endif()

# Add one target for running "ninja all" on the gyp generated bits.
# ${OXIDE_PLATFORM}/${OXIDE_PLATFORM}.gypi lists the targets that "all" depends on
find_program(_NINJA_EXE ninja)
if(_NINJA_EXE STREQUAL "_NINJA_EXE-NOTFOUND")
  message(FATAL_ERROR "Could not find ninja, which is required for building Oxide")
endif()
set(_NINJA_BUILD_COMMAND ${_NINJA_EXE} -C ${CHROMIUM_PRODUCT_DIR})
if(CMAKE_VERBOSE_MAKEFILE)
  list(APPEND _NINJA_BUILD_COMMAND -v)
endif()
list(APPEND _NINJA_BUILD_COMMAND all)
add_custom_target(
    build_all ALL COMMAND ${_NINJA_BUILD_COMMAND}
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    COMMENT "Running the build_all target")

# Copy chrome_sandbox to chrome-sandbox
add_custom_target(
    copy_chrome_sandbox ALL
    COMMAND ${CMAKE_COMMAND} -E copy_if_different
      ${CHROMIUM_PRODUCT_DIR}/chrome_sandbox ${CHROMIUM_PRODUCT_DIR}/chrome-sandbox
    DEPENDS build_all)

# Allow objects linked by cmake to declare a run-time dependency on the
# main library, built with gyp
add_library(${OXIDE_LIB} SHARED IMPORTED)
add_dependencies(${OXIDE_LIB} build_all)
set_target_properties(
    ${OXIDE_LIB} PROPERTIES
    IMPORTED_LOCATION ${CHROMIUM_LIB_DIR}/${OXIDE_LIB_FILENAME})

file(GLOB_RECURSE I18N_SRC_FILES
     RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
     ${OXIDE_PLATFORM}/**.cc shared/**.cc)
list(SORT I18N_SRC_FILES)

set(_OXIDE_INSTALL_LIB ${CHROMIUM_LIB_DIR}/${OXIDE_LIB_FILENAME})
set(_OXIDE_INSTALL_FILES
    ${CHROMIUM_PRODUCT_DIR}/oxide.pak
    ${CHROMIUM_PRODUCT_DIR}/oxide_100_percent.pak
    ${CHROMIUM_PRODUCT_DIR}/oxide_200_percent.pak
    ${CHROMIUM_PRODUCT_DIR}/icudtl.dat
    ${CHROMIUM_LIB_DIR}/${CMAKE_SHARED_LIBRARY_PREFIX}ffmpeg${CMAKE_SHARED_LIBRARY_SUFFIX}
    ${CHROMIUM_PRODUCT_DIR}/natives_blob.bin
    ${CHROMIUM_PRODUCT_DIR}/snapshot_blob.bin)
set(_OXIDE_INSTALL_PROGRAMS ${CHROMIUM_PRODUCT_DIR}/${OXIDE_RENDERER})
set(_CHROME_SANDBOX ${CHROMIUM_PRODUCT_DIR}/chrome-sandbox)
set(_OXIDE_INSTALL_LOCALEDIR ${CHROMIUM_PRODUCT_DIR}/locales)

install(FILES ${_OXIDE_INSTALL_LIB} DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(CODE
        "execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink
        ${OXIDE_LIB_FILENAME} ${OXIDE_LIB_FILENAME_DEV}
        WORKING_DIRECTORY \$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})")
install(FILES ${_OXIDE_INSTALL_FILES} DESTINATION ${OXIDE_INSTALL_LIBEXECDIR})
install(PROGRAMS ${_OXIDE_INSTALL_PROGRAMS}
        DESTINATION ${OXIDE_INSTALL_LIBEXECDIR})
install(PROGRAMS ${_CHROME_SANDBOX}
        DESTINATION ${OXIDE_INSTALL_LIBEXECDIR}
        PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE
                    GROUP_READ WORLD_EXECUTE WORLD_READ SETUID)
install(DIRECTORY ${_OXIDE_INSTALL_LOCALEDIR}
        DESTINATION ${OXIDE_INSTALL_LIBEXECDIR})
if(ENABLE_COMPONENT_BUILD)
  install(DIRECTORY ${CHROMIUM_LIB_DIR}
          DESTINATION ${OXIDE_INSTALL_LIBEXECDIR}
          FILES_MATCHING PATTERN "*${CMAKE_SHARED_LIBRARY_SUFFIX}")
endif()

add_subdirectory(po)
add_subdirectory(${OXIDE_PLATFORM})

add_custom_target(
    test-package-common-libs
    COMMAND ${CMAKE_COMMAND} -DFILES=${_OXIDE_INSTALL_LIB}
    -DTYPE=FILE -DDESTINATION=${OXIDE_PACKAGE_STAGE_DIR}
    -P ${CMAKE_SOURCE_DIR}/build/scripts/test-package-helper.cmake)
add_custom_target(
    test-package-common-programs
    COMMAND ${CMAKE_COMMAND}
    "-DFILES=\"${_OXIDE_INSTALL_PROGRAMS};${_CHROME_SANDBOX}\""
    -DTYPE=PROGRAM
    -DDESTINATION=${OXIDE_PACKAGE_STAGE_DIR}/${OXIDE_PLATFORM_FULLNAME}
    -P ${CMAKE_SOURCE_DIR}/build/scripts/test-package-helper.cmake)
add_custom_target(
    test-package-common-files
    COMMAND ${CMAKE_COMMAND} "-DFILES=\"${_OXIDE_INSTALL_FILES}\""
    -DTYPE=FILE
    -DDESTINATION=${OXIDE_PACKAGE_STAGE_DIR}/${OXIDE_PLATFORM_FULLNAME}
    -P ${CMAKE_SOURCE_DIR}/build/scripts/test-package-helper.cmake)
add_custom_target(
    test-package-common-locales
    COMMAND ${CMAKE_COMMAND} -DFILES=${_OXIDE_INSTALL_LOCALEDIR}
    -DTYPE=DIRECTORY
    -DDESTINATION=${OXIDE_PACKAGE_STAGE_DIR}/${OXIDE_PLATFORM_FULLNAME}
    -P ${CMAKE_SOURCE_DIR}/build/scripts/test-package-helper.cmake)
if(ENABLE_COMPONENT_BUILD)
  add_custom_target(
      test-package-common-component-libs
      COMMAND ${CMAKE_COMMAND} -DFILES=${CHROMIUM_LIB_DIR}
      -DMATCH_PATTERN="*${CMAKE_SHARED_LIBRARY_SUFFIX}" -DTYPE=DIRECTORY
      -DDESTINATION=${OXIDE_PACKAGE_STAGE_DIR}/${OXIDE_PLATFORM_FULLNAME}
      -P ${CMAKE_SOURCE_DIR}/build/scripts/test-package-helper.cmake)
endif()

add_custom_target(
    test-package-common
    DEPENDS test-package-common-libs
            test-package-common-programs
            test-package-common-files
            test-package-common-locales)
if(ENABLE_COMPONENT_BUILD)
  add_dependencies(test-package-common test-package-common-component-libs)
endif()

add_custom_target(
    test-package
    COMMAND ${CMAKE_COMMAND} -E
    tar czvf ${OXIDE_OUTPUT_DIR}/${OXIDE_PLATFORM_FULLNAME}.tar.bz2 *
    WORKING_DIRECTORY ${OXIDE_PACKAGE_STAGE_DIR}
    DEPENDS test-package-common test-package-${OXIDE_PLATFORM})

# Build the gyp command
set(_GYP_COMMAND
    ${PYTHON} ${CMAKE_SOURCE_DIR}/build/gyp_oxide
    -I${OXIDE_PLATFORM}/${OXIDE_PLATFORM}.gypi
    --generator-output ${CHROMIUM_OUTPUT_DIR}
    -Goutput_dir=${CHROMIUM_OUTPUT_DIR}
    ${OXIDE_GYP_EXTRA_ARGS})
list(APPEND _GYP_COMMAND -Doxide_lib=${OXIDE_LIB})
calculate_versioned_library_suffix(_OXIDE_LIB_SUFFIX ${OXIDE_LIB_VERSION})
string(REGEX REPLACE "^\\." "" _OXIDE_LIB_SUFFIX ${_OXIDE_LIB_SUFFIX})
list(APPEND _GYP_COMMAND -Doxide_lib_suffix=${_OXIDE_LIB_SUFFIX})
list(APPEND _GYP_COMMAND -Doxide_renderer=${OXIDE_RENDERER})
list(APPEND _GYP_COMMAND -Doxide_libexecdir=${OXIDE_PLATFORM_FULLNAME})
# oxide_build should be renamed to oxide_platform
list(APPEND _GYP_COMMAND -Doxide_build=${OXIDE_PLATFORM})
if(CMAKE_CROSSCOMPILING)
  if(NOT CHROMIUM_TARGET_ARCH)
    message(FATAL_ERROR "Need to set CHROMIUM_TARGET_ARCH when cross compiling")
  endif()
  list(APPEND _GYP_COMMAND -Dtarget_arch=${CHROMIUM_TARGET_ARCH})
endif()
if(DEFINED CMAKE_BUILD_TYPE AND CMAKE_BUILD_TYPE STREQUAL "Release")
  list(APPEND _GYP_COMMAND -Dlinux_dump_symbols=0)
else()
  list(APPEND _GYP_COMMAND -Dlinux_dump_symbols=1)
endif()
if(CMAKE_VERBOSE_MAKEFILE)
  list(APPEND _GYP_COMMAND -Dprint_ld_stats=1)
endif()
if(ENABLE_PROPRIETARY_CODECS)
  list(APPEND _GYP_COMMAND -Dffmpeg_branding=Chrome)
  list(APPEND _GYP_COMMAND -Dproprietary_codecs=1)
else()
  list(APPEND _GYP_COMMAND -Dffmpeg_branding=Chromium)
  list(APPEND _GYP_COMMAND -Dproprietary_codecs=0)
endif()
if(ENABLE_PLUGINS)
  list(APPEND _GYP_COMMAND -Denable_plugins=1)
else()
  list(APPEND _GYP_COMMAND -Denable_plugins=0)
endif()
if(ENABLE_TCMALLOC)
  list(APPEND _GYP_COMMAND -Denable_tcmalloc=1)
else()
  list(APPEND _GYP_COMMAND -Denable_tcmalloc=0)
endif()
if(ENABLE_COMPONENT_BUILD)
  list(APPEND _GYP_COMMAND -Dcomponent=shared_library)
endif()
list(APPEND _GYP_COMMAND -Doxide_gettext_domain=${GETTEXT_PACKAGE})
CHECK_INCLUDE_FILE_CXX("core/media/player.h" HAVE_MEDIAHUB "--std=c++11")
if(NOT HAVE_MEDIAHUB)
  list(APPEND _GYP_COMMAND -Denable_mediahub=0)
else()
  list(APPEND _GYP_COMMAND -Denable_mediahub=1)
endif()
if(USE_SYSTEM_PROTOBUF)
  list(APPEND _GYP_COMMAND -Duse_system_protobuf=1)
endif()
if(ENABLE_HYBRIS)
  list(APPEND _GYP_COMMAND -Denable_hybris=1)
else()
  list(APPEND _GYP_COMMAND -Denable_hybris=0)
endif()
if(ENABLE_HYBRIS_CAMERA)
  list(APPEND _GYP_COMMAND -Denable_hybris_camera=1)
else()
  list(APPEND _GYP_COMMAND -Denable_hybris_camera=0)
endif()
if(ENABLE_TESTS)
  list(APPEND _GYP_COMMAND -Denable_tests=1)
else()
  list(APPEND _GYP_COMMAND -Denable_tests=0)
endif()

if(CMAKE_CROSSCOMPILING)
  if(NOT CHROMIUM_C_HOST_COMPILER OR NOT CHROMIUM_CXX_HOST_COMPILER OR NOT CHROMIUM_HOST_AR)
    message(FATAL_ERROR "Need to specify host compilers when cross compiling")
  endif()
  set(ENV{CC_target} ${CMAKE_C_COMPILER})
  set(ENV{CXX_target} ${CMAKE_CXX_COMPILER})
  set(ENV{AR_target} ${CMAKE_AR})

=== qt/CMakeLists.txt ===
# vim:expandtab:shiftwidth=2:tabstop=2:

# Copyright (C) 2014-2015 Canonical Ltd.

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

include(GNUInstallDirs)

include(OxideCommonProperties)
include(OxidePackageConfigHelper)

set(OXIDE_QMLPLUGIN_OUTPUT_DIR ${CMAKE_BINARY_DIR}/out/imports)

set(OXIDE_QUICKLIB OxideQtQuick)

if(CMAKE_CROSSCOMPILING)
  # Dummy targets - not used anywhere, but this stops Qt5CoreConfigExtras.cmake
  # from creating them and checking if the binary exists, which is broken when
  # cross-building because it checks for the target system binary. We need the
  # host system binaries installed, because they are in the same package as the
  # moc in Ubuntu (qtbase5-dev-tools), which is not currently multi-arch
  if(NOT TARGET Qt5::qmake)
    add_executable(Qt5::qmake IMPORTED)
  endif()
  if(NOT TARGET Qt5::rcc)
    add_executable(Qt5::rcc IMPORTED)
  endif()
  if(NOT TARGET Qt5::uic)
    add_executable(Qt5::uic IMPORTED)
  endif()
endif()

find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
# 5.2.0 is required for us to be able to set a share context
find_package(Qt5Quick 5.2.0 REQUIRED)

set(_OXIDEQMLSCENE_DEFAULT OFF)
if(${Qt5Quick_VERSION_STRING} VERSION_LESS "5.3.0")
  set(_OXIDEQMLSCENE_DEFAULT ON)
endif()
option(ENABLE_OXIDEQMLSCENE "Enable the oxideqmlscene binary" ${_OXIDEQMLSCENE_DEFAULT})

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/run_qmlapp.sh.in
    ${CMAKE_CURRENT_BINARY_DIR}/run_qmlapp.sh
    IMMEDIATE @ONLY)
file(INSTALL ${CMAKE_CURRENT_BINARY_DIR}/run_qmlapp.sh
     DESTINATION ${OXIDE_BIN_OUTPUT_DIR}
     FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
         GROUP_READ GROUP_EXECUTE
         WORLD_READ WORLD_EXECUTE)

configure_and_install_package_config_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/core/api/OxideQtCoreConfig.cmake.in)

# See https://launchpad.net/1578808 - QOpenGLFunctions methods in builds
#  that define QT_OPENGL_ES_2 use GLESv2 symbols inline
set(CMAKE_REQUIRED_INCLUDES ${Qt5Gui_INCLUDE_DIRS} ${Qt5Core_INCLUDE_DIRS})
set(CMAKE_REQUIRED_LIBRARIES ${Qt5Gui_LIBRARIES})
check_cxx_source_compiles(
    "#include <QOpenGLFunctions>
    #ifndef QT_OPENGL_ES_2
    # error
    #endif
    int main(int argc, char** argv) { return 0; }
    " QTGUI_OPENGL_REQUIRES_GL_LINKING)

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/core/api/
        DESTINATION ${OXIDE_INSTALL_INCLUDEDIR}/OxideQtCore
        FILES_MATCHING PATTERN *.h
        PATTERN *_p.h EXCLUDE
        PATTERN includes* EXCLUDE)

set_target_properties(
    ${OXIDE_LIB} PROPERTIES
    INTERFACE_INCLUDE_DIRECTORIES ${CMAKE_CURRENT_SOURCE_DIR}/core/api/includes
    INTERFACE_LINK_LIBRARIES Qt5::Core)

set(OXIDE_QT_PACKAGE_QMLPLUGIN_DIR qml)

add_subdirectory(qmlplugin)
add_subdirectory(quick)

if(ENABLE_OXIDEQMLSCENE)
  if(NOT ${Qt5Quick_VERSION_STRING} VERSION_LESS "5.4.0")
    message(FATAL_ERROR
            "oxideqmlscene is not supported on Qt 5.4.0 and later - you can "
            "use qmlscene instead")
  elseif(NOT ${Qt5Quick_VERSION_STRING} VERSION_LESS "5.3.0")
    message(WARNING
            "oxideqmlscene is redundant on Qt 5.3.0 and later - you can use "
            "qmlscene instead")
  endif()
  add_subdirectory(qmlrunner)
endif()

if(ENABLE_TESTS)
  add_subdirectory(tests)
endif()

add_custom_target(
    test-package-qt-runner
    COMMAND ${CMAKE_COMMAND}
    -DSRCFILE=${CMAKE_CURRENT_SOURCE_DIR}/run_qmlapp.sh.in
    -DDESTINATION=${OXIDE_PACKAGE_STAGE_DIR}
    -DQML_DIR=${OXIDE_QT_PACKAGE_QMLPLUGIN_DIR}
    -DPRODUCT_DIR=${OXIDE_PLATFORM_FULLNAME} -DOXIDE_RENDERER=${OXIDE_RENDERER}
    -P ${CMAKE_CURRENT_SOURCE_DIR}/build/scripts/make-test-package-qmlrunner.cmake)

add_custom_target(
    test-package-qt
    DEPENDS test-package-qt-quick test-package-qt-qmlplugin test-package-qt-runner)

=== qt/quick/CMakeLists.txt ===
# vim:expandtab:shiftwidth=2:tabstop=2:

# Copyright (C) 2014-2016 Canonical Ltd.

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

include(GNUInstallDirs)

include(OxideCommonProperties)
include(OxidePackageConfigHelper)

find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Qml REQUIRED)
find_package(Qt5Quick REQUIRED)

qt5_wrap_cpp(MOC_EXTRA
             api/oxideqquickwebcontextdelegateworker_p_p.h)

set(OXIDE_QUICKLIB_SRCS
    api/oxideqquickcookiemanager.cc
    api/oxideqquickglobal.cc
    api/oxideqquicklocationbarcontroller.cc
    api/oxideqquicknavigationhistory.cc
    api/oxideqquickscriptmessage.cc
    api/oxideqquickscriptmessagehandler.cc
    api/oxideqquickscriptmessagerequest.cc
    api/oxideqquicktouchselectioncontroller.cc
    api/oxideqquickuserscript.cc
    api/oxideqquickwebcontext.cc
    api/oxideqquickwebcontextdelegateworker.cc
    api/oxideqquickwebframe.cc
    api/oxideqquickwebview.cc
    api/oxidequseragentoverriderequest.cc
    oxide_qquick_accelerated_frame_node.cc
    oxide_qquick_alert_dialog.cc
    oxide_qquick_before_unload_dialog.cc
    oxide_qquick_confirm_dialog.cc
    oxide_qquick_contents_view.cc
    oxide_qquick_file_picker.cc
    oxide_qquick_image_frame_node.cc
    oxide_qquick_init.cc
    oxide_qquick_javascript_dialog.cc
    oxide_qquick_prompt_dialog.cc
    oxide_qquick_software_frame_node.cc
    oxide_qquick_touch_handle_drawable.cc
    oxide_qquick_web_context_menu.cc
    oxide_qquick_web_popup_menu.cc
    ${MOC_EXTRA})

add_library(${OXIDE_QUICKLIB} SHARED ${OXIDE_QUICKLIB_SRCS})
target_compile_definitions(
    ${OXIDE_QUICKLIB} PRIVATE -DOXIDE_QTQUICK_IMPLEMENTATION)
target_include_directories(
    ${OXIDE_QUICKLIB} PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/api/includes)
target_include_directories(
    ${OXIDE_QUICKLIB} PRIVATE
    ${Qt5Core_PRIVATE_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${Qt5Quick_PRIVATE_INCLUDE_DIRS})
target_link_libraries(
    ${OXIDE_QUICKLIB}
    PUBLIC Qt5::Core Qt5::Qml Qt5::Quick
    PRIVATE Qt5::Gui ${OXIDE_LIB})
if(QTGUI_OPENGL_REQUIRES_GL_LINKING)
  target_link_libraries(${OXIDE_QUICKLIB} PRIVATE ${Qt5Gui_OPENGL_LIBRARIES})
endif()
set_target_properties(
    ${OXIDE_QUICKLIB} PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${OXIDE_LIB_OUTPUT_DIR}
    AUTOMOC TRUE
    SOVERSION ${OXIDE_LIB_VERSION})

install(TARGETS ${OXIDE_QUICKLIB} DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/api/
        DESTINATION ${OXIDE_INSTALL_INCLUDEDIR}/OxideQtQuick
        FILES_MATCHING PATTERN *.h
        PATTERN *_p.h EXCLUDE
        PATTERN includes* EXCLUDE)

add_custom_target(
    test-package-qt-quick
    COMMAND ${CMAKE_COMMAND} -DFILES=$<TARGET_FILE:${OXIDE_QUICKLIB}>
    -DTYPE=FILE -DDESTINATION=${OXIDE_PACKAGE_STAGE_DIR}
    -P ${CMAKE_SOURCE_DIR}/build/scripts/test-package-helper.cmake)

calculate_versioned_library_filename(OXIDE_QUICKLIB_FILENAME ${OXIDE_QUICKLIB} ${OXIDE_LIB_VERSION})
configure_and_install_package_config_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/api/OxideQtQuickConfig.cmake.in)

=== qt/tests/CMakeLists.txt ===
# vim:expandtab:shiftwidth=2:tabstop=2:

# Copyright (C) 2014-2016 Canonical Ltd.

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

set(OXIDE_MOCK_QTPLUGIN_DIR ${CMAKE_CURRENT_BINARY_DIR}/mock)

add_subdirectory(mock)
add_subdirectory(unit)
add_subdirectory(qmltests)

=== qt/tests/qmltests/CMakeLists.txt ===
# vim:expandtab:shiftwidth=2:tabstop=2:

# Copyright (C) 2014-2015 Canonical Ltd.

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

include(AutoGenerateHelper)

find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Qml REQUIRED)
find_package(Qt5Quick REQUIRED)
find_package(Qt5QuickTest REQUIRED)
find_package(Qt5Test REQUIRED)

set(QML_SUPPORT_MODULE_NAME Oxide/testsupport)
set(QML_SUPPORT_IMPORT_DIR ${CMAKE_CURRENT_BINARY_DIR})
set(QML_SUPPORT_MODULE_DIR ${QML_SUPPORT_IMPORT_DIR}/${QML_SUPPORT_MODULE_NAME})

add_custom_command(
    OUTPUT ${QML_SUPPORT_MODULE_DIR}
    COMMAND ${CMAKE_COMMAND} -E make_directory ${QML_SUPPORT_MODULE_DIR})
add_custom_target(
    make_testsupport_dir ALL
    DEPENDS ${QML_SUPPORT_MODULE_DIR})
    
foreach(f
    qmldir
    ScriptMessageTestHandler.qml
    ScriptMessageTestUtils.js
    ScriptMessageTestUtilsUserScript.js
    TestUtils.js
    TestUtilsSlave.js
    TestWebContext.qml
    TestWebView.qml)
  add_custom_command(
      OUTPUT ${QML_SUPPORT_MODULE_DIR}/${f}
      COMMAND ${CMAKE_COMMAND} -E copy
        ${CMAKE_CURRENT_SOURCE_DIR}/${f} ${QML_SUPPORT_MODULE_DIR}/${f}
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${f} ${QML_SUPPORT_MODULE_DIR})
  add_custom_target(
      copy_testsupport_file_${f} ALL
      DEPENDS ${QML_SUPPORT_MODULE_DIR}/${f})
endforeach()

set(QML_TEST_SHARED qmltestshared)
set(QML_TEST_SHARED_SRCS
    qml_test_support.cc
    quick_test_compat.cc
    test_nam_factory.cc)

add_library(${QML_TEST_SHARED} STATIC ${QML_TEST_SHARED_SRCS})
target_link_libraries(
    ${QML_TEST_SHARED}
    Qt5::Core
    Qt5::Gui
    Qt5::Qml
    Qt5::Test
    ${OXIDE_LIB}
    ${OXIDE_QUICKLIB})
set_target_properties(${QML_TEST_SHARED} PROPERTIES AUTOMOC TRUE)

set(QML_TEST_SRCS main.cc)

function(add_qml_test)
  cmake_parse_arguments(_ARGS "SINGLE_PROCESS" "EXCLUDE_LIST;EXEC;NAME;TEST_DIR" "" "${ARGN}")

  if(NOT DEFINED _ARGS_EXEC)
    message(FATAL_ERROR "Missing option EXEC")
  endif()
  if(NOT DEFINED _ARGS_NAME)
    message(FATAL_ERROR "Missing option NAME")
  endif()

  if(NOT DEFINED _ARGS_TEST_DIR)
    set(_ARGS_TEST_DIR ${CMAKE_CURRENT_SOURCE_DIR})
  endif()

  if(NOT TARGET ${_ARGS_EXEC})
    add_executable(${_ARGS_EXEC} ${QML_TEST_SRCS})
    target_compile_definitions(
        ${_ARGS_EXEC} PRIVATE
        -DQML_TEST_PATH="${_ARGS_TEST_DIR}")
    target_link_libraries(
        ${_ARGS_EXEC}
        ${QML_TEST_SHARED}
        Qt5::Core
        Qt5::Gui
        Qt5::Qml
        Qt5::Quick
        Qt5::QuickTest
        Qt5::Test
        ${OXIDE_LIB})
    target_include_directories(
        ${_ARGS_EXEC} PRIVATE
        ${Qt5Core_PRIVATE_INCLUDE_DIRS}
        ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
        ${Qt5Quick_PRIVATE_INCLUDE_DIRS}
        ${Qt5QuickTest_PRIVATE_INCLUDE_DIRS})
    set_target_properties(${_ARGS_EXEC} PROPERTIES AUTOMOC TRUE)
  endif()

  set(_CONFIG ${OXIDE_OUTPUT_DIR}/test_configs/${_ARGS_NAME}.conf)

  set(QML_TEST_EXEC $<TARGET_FILE:${_ARGS_EXEC}>)
  set(QT_PLUGIN_PATH ${OXIDE_MOCK_QTPLUGIN_DIR})
  set(HTTP_SERVER_DIR ${_ARGS_TEST_DIR})
  set(QML_IMPORT_PATH ${QML_SUPPORT_IMPORT_DIR})
  set(SINGLE_PROCESS false)
  if(_ARGS_SINGLE_PROCESS)
    set(SINGLE_PROCESS true)
  endif()
  set(EXCLUDE_LIST "")
  if(_ARGS_EXCLUDE_LIST)
    set(EXCLUDE_LIST ${_ARGS_EXCLUDE_LIST})
  endif()

  auto_generate_file(
      OUTPUT ${_CONFIG}
      INPUT ${CMAKE_CURRENT_SOURCE_DIR}/qml-test.conf.in
      VARS QML_TEST_EXEC QT_PLUGIN_PATH HTTP_SERVER_DIR QML_IMPORT_PATH SINGLE_PROCESS EXCLUDE_LIST)

  set(_COMMAND
      ${OXIDE_BIN_OUTPUT_DIR}/run_qmlapp.sh
      ${PYTHON} ${CMAKE_SOURCE_DIR}/qt/tests/runtests.py
      --config ${_CONFIG})
  add_test(NAME ${_ARGS_NAME} COMMAND ${_COMMAND})
endfunction()

add_qml_test(EXEC qmltest_api NAME qml-api-test
             TEST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/api)
add_qml_test(EXEC qmltest_core NAME qml-core-test
             TEST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/core)
add_qml_test(EXEC qmltest_web_platform NAME qml-web-platform-test
             TEST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/web_platform)
add_qml_test(EXEC qmltest_crash NAME qml-crash-test
             TEST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/crash)
add_qml_test(EXEC qmltest_api NAME qml-api-single-process-test
             TEST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/api
             SINGLE_PROCESS
             EXCLUDE_LIST ${CMAKE_CURRENT_SOURCE_DIR}/api/single-process.exclude)
add_qml_test(EXEC qmltest_core NAME qml-core-single-process-test
             TEST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/core
             SINGLE_PROCESS
             EXCLUDE_LIST ${CMAKE_CURRENT_SOURCE_DIR}/core/single-process.exclude)
add_qml_test(EXEC qmltest_web_platform NAME qml-web-platform-single-process-test
             TEST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/web_platform SINGLE_PROCESS)
add_qml_test(EXEC qmltest_crash NAME qml-crash-single-process-test
             TEST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/crash SINGLE_PROCESS)

=== qt/tests/mock/position/CMakeLists.txt ===
# vim:expandtab:shiftwidth=2:tabstop=2:

# Copyright (C) 2014-2015 Canonical Ltd.

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Positioning REQUIRED)

set(PLUGIN mock)

set(PLUGIN_SRCS
    source.cc
    plugin.cc)

add_library(${PLUGIN} SHARED ${PLUGIN_SRCS})
target_link_libraries(${PLUGIN}
    Qt5::Core
    Qt5::Gui
    Qt5::Positioning)
target_compile_definitions(${PLUGIN} PRIVATE -DQT_PLUGIN)
set_target_properties(${PLUGIN} PROPERTIES AUTOMOC TRUE)

=== qt/tests/unit/oxideqcertificateerror/CMakeLists.txt ===
# vim:expandtab:shiftwidth=2:tabstop=2:

# Copyright (C) 2016 Canonical Ltd.

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Test REQUIRED)

add_executable(tst_oxideqcertificateerror tst_oxideqcertificateerror.cc)
target_link_libraries(tst_oxideqcertificateerror
                      PRIVATE ${OXIDE_LIB} Qt5::Core Qt5::Gui Qt5::Test)
set_target_properties(tst_oxideqcertificateerror PROPERTIES
                      AUTOMOC TRUE)

add_test(NAME tst_oxideqcertificaterror
         COMMAND ${OXIDE_BIN_OUTPUT_DIR}/run_qmlapp.sh
                 ${CMAKE_CURRENT_BINARY_DIR}/tst_oxideqcertificateerror)

=== qt/tests/unit/oxideqdownloadrequest/CMakeLists.txt ===
# vim:expandtab:shiftwidth=2:tabstop=2:

# Copyright (C) 2016 Canonical Ltd.

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Test REQUIRED)

add_executable(tst_oxideqdownloadrequest tst_oxideqdownloadrequest.cc)
target_link_libraries(tst_oxideqdownloadrequest
                      PRIVATE ${OXIDE_LIB} Qt5::Core Qt5::Gui Qt5::Test)
set_target_properties(tst_oxideqdownloadrequest PROPERTIES
                      AUTOMOC TRUE)

add_test(NAME tst_oxideqdownloadrequest
         COMMAND ${OXIDE_BIN_OUTPUT_DIR}/run_qmlapp.sh
                 ${CMAKE_CURRENT_BINARY_DIR}/tst_oxideqdownloadrequest)

=== debian/changelog ===
oxide-qt (1.15.8-0ubuntu0.15.10.1) wily-security; urgency=medium

  * Update to v1.15.8 (see USN-3015-1)
    - Bump Chromium rev to 51.0.2704.103
    - Fix LP: #1590776 - Hide the insertion handle on input events

 -- Chris Coulson <chris.coulson@canonical.com>  Wed, 22 Jun 2016 15:54:24 +0100

oxide-qt (1.15.7-0ubuntu0.15.10.1) wily-security; urgency=medium

  * Update to v1.15.7 (see USN-2992-1)
    - Bump Chromium rev to 51.0.2704.79
    - Fix LP: #1567542 - Ensure the camera image is rotated correctly for both
      front and back cameras, and fix a krillin-specific issue
    - Fix LP: #1570511 / LP: #1586968 - Allow touch selection to short circuit
      context menu requests
    - Fix LP: #1569315 - Make WebView::EditingCapabilitiesChanged faster to
      avoid serious performance issues with an active selection
    - Disable plugins by default on arm, as we only support Flash which isn't
      available there
    - Compile native arm and x86 builds with -g1 to reduce the size of the
      resulting unstripped binary and hopefully ease address space pressure
      during linking. This will reduce the usefulness of crash reports on
      these platforms
    - Unbreak the !ENABLE_PLUGINS build
    - Fix LP: #1582060 - Ensure we attach the InputMethodContext for script
      opened webviews
    - Fix LP: #1578808 - link failure on armhf
    - Fix LP: #1576164 - Internationalize the camera names
    - Fix LP: #1556658 - Provide dummy message text to an application's custom
      beforeunload dialog component for compatibility purposes, now that
      Chromium ignores the one provided by the page
    - Fix LP: #1535818 - Add support for the deviceId constraint in getUserMedia
    - Fix LP: #1568860 - Replace use of scoped_ptr with std::unique_ptr
    - Replace CertificateErrorDispatcherClient with a callback, and add through
      unit tests for CertificateErrorDispatcher in the process
    - Add the ability to run unit tests on internal classes in shared/
    - Fix LP: #1447395 - Add WebView.zoomFactor API
    - Fix LP: #1565063 - Add 'version' and 'chromiumVersion' properties to
      the API
    - Remove CompositorProxy and its implementation. This was left over from
      when the webview compositor wasn't single threaded
    - Remove RendererFrameEvictor - it's redundant anyway because we destroy
      the webview compositor when it's hidden. Now we just drive eviction from
      there instead. This removes a bogus dependency on GetFormFactorHint
    - Hide surface_id from compositor clients, cleaning up the client interface
    - Fix LP: #1498200 - Componentize qt/core/ and shared/. This allows us to
      build unit test binaries that depend on shared/
    - Drop the warning when changing the process model - single process is
      now supported.
    - Adapt the QML tests to run in single-process and make lots of test fixes
      (LP: #1399208)
    - Fix LP: #1399207 - Make it possible to skip entire QML test cases where
      they aren't relevant for specific configurations (eg, single process)
    - Fix LP: #1462814 - Drop failing test which appears to not be useful
      anymore
    - Disable profiler timing - we don't have chrome://profiler/, and this is
      disabled by default on Chrome/Android too due to it having a
      non-negligible performance impact.
    - Fix a shutdown abort in single-process mode
    - Add CookieStoreUIProxy, which is an implementation of net::CookieStore
      that proxies calls from the UI thread to the real cookie store on the IO
      thread. This is used in a couple of places where we need access to the
      cookie store on the UI thread
    - Fix LP: #1556762 - Add TouchSelectionController.handleDragInProgress
      property
    - Fix LP: #1556764 - Add TouchSelectionController.hide() API
    - Fix LP: #1552161 - Convert QTouchEvent directly to ui::MotionEvent.
      Dropping the use of ui::TouchEvent means we no longer have to round
      the scroll coordinates, which should improve smoothness on high-DPI
      screens

 -- Chris Coulson <chris.coulson@canonical.com>  Thu, 02 Jun 2016 18:51:03 +0100

oxide-qt (1.14.9-0ubuntu0.15.10.1) wily-security; urgency=medium

  * Update to v1.14.9 (see USN-2960-1)
    - Bump Chromium rev to 50.0.2661.102
    - Scale the locationbar height when the screen changes
    - Fix LP: #1575216 - Ensure we resize / rescale the webview compositor
      viewport when the screen is updated

 -- Chris Coulson <chris.coulson@canonical.com>  Wed, 04 May 2016 20:06:21 +0100

oxide-qt (1.14.7-0ubuntu0.15.10.1) wily-security; urgency=medium

  * Update to v1.14.7
    - Bump Chromium rev to 50.0.2661.87
    - Fix LP: #1565685 - Gracefully handle the case where
      glGetString(GL_SHADING_LANGUAGE_VERSION) returns a null pointer
    - Fix LP: #1543761 - Move fullscreen logic out of oxide::WebView
    - Fix LP: #1542119 - Rip input handling and compositing glue out of
      oxide::WebView
    - Fix LP: #1548996 - Fix device scaling mess
    - Fix LP: #1459830 - Support drag and drop
    - Fix LP: #1440863 - Support navigator.vibrate()
    - Fix LP: #1552376 - Ensure we disable the use of the share context on
      drivers where Chromium uses virtualized GL contexts
    - Fix LP: #1520537 - webbrowser-app crashes after 1 sec on unity8
    - Fix LP: #1459395 - Triple click doesn't work
    - Fix LP: #1459362 - SwipeArea lets touch events through before a drag is
      detected
    - Fix LP: #1426153 - Use a single-threaded webview compositor
    - Fix LP: #1543587 - Duplicate targets and random mis-builds due to
      Chromedriver
    - Fix LP: #1555122 - Startup crash when running in a VM
    - Fix LP: #1552825 - WebView.touchSelectionController.active remains true
      when navigating away
    - Fix LP: #1556323 - Fix SIGSEGV in oxide::InputMethodContext::SetImeBridge
    - Add support for scale factor retrieved from the Ubuntu QPA plugin
    - Switch from DelegatedRendererLayer to SurfaceLayer in


=== debian/control ===
Source: oxide-qt
Section: libs
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper (>= 8.0.0),
    cmake,
    qt5-qmake,
    qt5-default,
    qtdeclarative5-dev,
    qtbase5-private-dev,
    qtdeclarative5-private-dev,
    qtpositioning5-dev,
    qtfeedback5-dev,
    ninja-build,
    python,
    pkg-config,
    libglib2.0-dev,
    libnss3-dev,
    libpci-dev,
    libgcrypt11-dev,
    libdbus-1-dev,
    libudev-dev,
    libpulse-dev,
    libasound2-dev,
    libx11-dev,
    libxi-dev,
    libcap-dev,
    libdrm-dev,
    libfontconfig1-dev,
    libfreetype6-dev,
    libpango1.0-dev,
    libxext-dev,
    libxcomposite-dev,
    libxrender-dev,
    libkrb5-dev,
    libssl-dev,
    libgdk-pixbuf2.0-dev,
    libnotify-dev,
    gperf,
    bison,
    xvfb,
    qtdeclarative5-qtquick2-plugin,
    qtdeclarative5-test-plugin,
    libexif-dev,
    libxcursor-dev,
    libxrandr-dev,
    libxtst-dev,
    libmedia-hub-dev [armhf],
    libandroid-properties-dev,
    libffi-dev
Standards-Version: 3.9.5
Homepage: https://launchpad.net/oxide

Package: liboxideqtcore0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
    ${misc:Depends},
    oxideqt-codecs (= ${binary:Version}) | oxideqt-codecs-extra (= ${binary:Version})
Description: Web browser engine for Qt (core library and components)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the core library, sandbox, renderer and support
 files required to run applications with Oxide

Package: liboxideqtcore-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
    ${misc:Depends},
    liboxideqtcore0 (= ${binary:Version})
Description: Web browser engine for Qt (development files for core library)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the development files required to compile programs
 against the Oxide core library

Package: liboxideqtquick0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
    liboxideqtcore0 (= ${binary:Version}),
    oxideqt-codecs (= ${binary:Version}) | oxideqt-codecs-extra (= ${binary:Version})
Description: Web browser engine for Qt (QtQuick library)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the QtQuick library required to run QML applications
 with Oxide

Package: liboxideqtquick-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
    ${misc:Depends},
    liboxideqtquick0 (= ${binary:Version})
Description: Web browser engine for Qt (development files for QtQuick library)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the development files required to compile programs
 against the Oxide QtQuick library

Package: liboxideqt-qmlplugin
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
    liboxideqtcore0 (= ${binary:Version}),
    liboxideqtquick0 (= ${binary:Version})
Description: Web browser engine for Qt (QML plugin)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the QML plugin required to run QML applications with
 Oxide

Package: oxideqt-dbg
Architecture: any
Section: debug
Depends: ${misc:Depends},
    liboxideqtcore0 (= ${binary:Version}),
    liboxideqtquick0 (= ${binary:Version}),
    liboxideqt-qmlplugin (= ${binary:Version})
Description: Web browser engine for Qt (Debug symbols)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the debugging symbols for Oxide

Package: oxideqt-codecs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: oxideqt-codecs-extra
Breaks: liboxideqtcore0 (<< 1.0.0~bzr488)
Replaces: oxideqt-codecs-extra, liboxideqtcore0 (<< 1.0.0~bzr488)
Description: Web browser engine for Qt (codecs)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides some media codecs needed for the HTML5 <audio> and
 <video> tags. Included are the free Theora, Vorbis, Opus, VP8 and VP9
 codecs

Package: oxideqt-codecs-dbg
Architecture: any
Section: debug
Depends: ${misc:Depends},
    oxideqt-codecs (= ${binary:Version})
Conflicts: oxideqt-codecs-extra-dbg
Breaks: oxideqt-dbg (<< 1.0.0~bzr488)
Replaces: oxideqt-codecs-extra-dbg, oxideqt-dbg (<< 1.0.0~bzr488)
Description: Web browser engine for Qt (Debug symbols)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the debugging symbols for Oxide

Package: oxideqt-codecs-extra
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: oxideqt-codecs
Breaks: liboxideqtcore0 (<< 1.0.0~bzr488)
Replaces: oxideqt-codecs, liboxideqtcore0 (<< 1.0.0~bzr488)
Description: Web browser engine for Qt (codecs)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides some media codecs needed for the HTML5 <audio> and
 <video> tags. Included are the Theora, Vorbis, Opus, VP8, VP9, MP3, AAC
 and H.264 codecs

Package: oxideqt-codecs-extra-dbg
Architecture: any
Section: debug
Depends: ${misc:Depends},
    oxideqt-codecs-extra (= ${binary:Version})
Conflicts: oxideqt-codecs-dbg
Breaks: oxideqt-dbg (<< 1.0.0~bzr488)
Replaces: oxideqt-codecs-dbg, oxideqt-dbg (<< 1.0.0~bzr488)
Description: Web browser engine for Qt (Debug symbols)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the debugging symbols for Oxide

Package: oxideqt-chromedriver
Architecture: any
Section: misc
Depends: ${misc:Depends}
Description: Web browser engine for Qt (transitional package)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This is a transitional package to make upgrades work correctly, and can be
 safely removed

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
COMMON_OPTIONS := -DENABLE_TESTS=1

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- $(COMMON_OPTIONS) -DENABLE_PROPRIETARY_CODECS=1

override_dh_auto_test:
	#xvfb-run -a -s "-screen 0 1024x768x24" dh_auto_test --max-parallel=1

override_dh_auto_install:
	dh_auto_install
	dh_auto_configure -- $(COMMON_OPTIONS) -DENABLE_PROPRIETARY_CODECS=0
	dh_auto_build
	dh_auto_install --destdir debian/tmp.free

override_dh_install:
	dh_install
	dh_install -poxideqt-codecs --sourcedir=debian/tmp.free usr/lib/$(DEB_HOST_MULTIARCH)/oxide-qt/libffmpeg.so

override_dh_strip:
	dh_strip -pliboxideqtcore0 --dbg-package=oxideqt-dbg
	dh_strip -pliboxideqtquick0 --dbg-package=oxideqt-dbg
	dh_strip -pliboxideqt-qmlplugin --dbg-package=oxideqt-dbg
	dh_strip -poxideqt-codecs --dbg-package=oxideqt-codecs-dbg
	dh_strip -poxideqt-codecs-extra --dbg-package=oxideqt-codecs-extra-dbg

override_dh_fixperms:
	dh_fixperms
	chmod 4755 debian/liboxideqtcore0/usr/lib/*/oxide-qt/chrome-sandbox
